/*
  Copyright (C) MOXA Inc. All rights reserved.
  This software is distributed under the terms of the
  MOXA License.  See the file COPYING-MOXA for details.
*/

/* 
 * This file is an example of the EPM-3438 couter programming.
 * 1. read the counter value.
 * 2. read the counter value and reset the counter.
 * 3. reset the counter.
 *
 * Copyright Moxa Systems L.T.D.
 *
 * History:
 * Date		Author			Comment
 * 07-22-2010	Jared Wu.		First create for counter reading on EPM-3438
 */

#include	<stdio.h>
#include	<stdlib.h>
#include	<sys/time.h>
#include	<fcntl.h>
#include	<unistd.h>
#include	<signal.h>
#include	"mxdgio.h" // For EPM-3438 counter reading or reset

#define COUNTER_NODE1	"/dev/epm_3438_counter1" // The counter of first EPM-3438 
#define COUNTER_NODE2	"/dev/epm_3438_counter2" // The counter of second EPM-3438

int main(int argc, char * argv[])
{
	int retval;
	int fd;
        //int fd2;
	unsigned int counter_value;

	fd=open(COUNTER_NODE1, O_RDONLY);
	//fd2=open(COUNTER_NODE2, O_RDONLY);

	while( 1 ) {
		printf("\nSelect a number of menu, other key to exit.	\n\
	1.Get counter value				\n\
	2.Clear the counter	\n\
	Others. quit					\n\
Choose : ");

		scanf("%d", &retval);
		if ( retval == 1 ) {	// Get counter without reset
			counter_value = mxdgio_epm3438_get_counter(fd);
			printf("EPM-3438 board #1 counter:%d\n", counter_value);
		}
		else if ( retval == 2 ) { // Get counter with reset
			retval = mxdgio_epm3438_clear_counter(fd);
			if ( retval < 0 )
				printf("EPM-3438 board #1 counter reset fail\n");
		}
		else {
			break;
		}

	}

	close(fd);
	//close(fd2);

	return 0;
}
